//                                        - Proximity to MA"
// Original idea from PipEasy and the equity millipede thread at forexfactory.com"
#property copyright "SABTrader. Free use of this is granted to all."
#define IndicName "Proximity to MA"
// This is version 3 completed on 8th Oct 2010 by SABTrader.

//                                        - external inputs -
extern bool Repaint = true;
extern bool Enable_Alerts = true;
extern bool Enable_EMails = false;
extern int  MaxnBars = 1000;//2000; // Max n bars to calc

//                                        - Buffers -
#define nB 2 // n.o.Buffers
#property indicator_chart_window
#property indicator_buffers nB

//                                        - global variables -
bool 
   initdone = false;
int
  MA_Period  = 200,
  MA_Mode = MODE_EMA,
  ProxLast, // (price - ema) old
  ndigits,
  MAMode = MODE_EMA, 
  MAappliedprice = PRICE_CLOSE; // close or hlc/3
double
  ma200[], temp[], // ind buffers 
  onepip, topips;
string
  box = "boxtoshowemaisclosenow";
  
//                                        - init() -
int init()
{
Print ("Init()  ------------------------------");

  IndicatorShortName(IndicName);
  Comment(IndicName);
    
  if (MA_Period <=20)
    MAappliedprice = PRICE_TYPICAL;
      
  //-- Buffers
  IndicatorBuffers(nB);
  SetIndexBuffer(0, ma200); 
  SetIndexLabel(0,"EMA("+MA_Period+")");     
  SetIndexStyle(0,DRAW_LINE,0,2,Yellow);
 
  SetIndexBuffer(1, temp); 
  SetIndexLabel(1,"Prox");     
  SetIndexStyle(1,DRAW_NONE,0,2,Yellow);
 
  switch(Digits)
  { case 2: onepip = 0.01;  ndigits=2; topips = 1/Point; break;   //xxxjpy
    case 3: onepip = 0.01;  ndigits=2; topips = 0.1/Point; break; // mbtjpy
    case 4: onepip = 0.0001; ndigits=4; topips = 1/Point; break;
    case 5: onepip = 0.0001; ndigits=4; topips = 0.1/Point; break;
  }
  Print("Onepip = "+onepip);
  
  IndicatorDigits(ndigits+1); // for data window
  
  ObjectCreate( box , 16, 0, 20, 1.1, 10, 2.2);
  ObjectSet(box,OBJPROP_SCALE,1.0);
  ObjectSet(box, OBJPROP_TIMEFRAMES,0); // show on all
}


//                                        - start() -

int start()

{ 
  bool
     newbar = fNewBar();   
  int 
    i,
    p = 400,  // proximity now
    nBarsToDo,
    counted_bars=IndicatorCounted()+1; // =nBars changed since last time indic run.
  double
    ma1 = ma200[1]; // ma200[0] not always valid
 
  if (Bars < MA_Period) 
  { //Print( "Start: Bars < MA_Period. Bars = "+Bars );   
    return (-2); // not enough bars for ma()
  }
  
  nBarsToDo = (Bars - counted_bars); // = (All - BarsNotDone)
 
  if (nBarsToDo>MaxnBars)
    nBarsToDo=MaxnBars; // external input 
 
  //                                        - Calcs -
   
  while (nBarsToDo>=1) // don't do 0 bar
  { 
    DPips(nBarsToDo); // fills indic buffer
    nBarsToDo--; 
  } // end while
     
  if (newbar) 
  { p = DPips(1);  // uses bar 1
  }
 
  
  if (Repaint) // use bar 0  
  { 
    p = MathRound((Close[0]-ma1)*topips); // for speed use ma1 here
    temp[0] = p; // for debug
  }
  
  if (p != ProxLast) //if proximity has changed update box position
  {
    //Print("(p != ProxLast)         p = "+p);
     
    ProxLast = p;
    Comment(IndicName+" = "+p+" pips"); // top left corner of window
    
    if ((p<= 40)&&(p>=0)) // Draw a green box
    { ObjectSet( box, OBJPROP_COLOR, Green);
      datetime 
        t = iTime( NULL, 0, WindowFirstVisibleBar()); // lhs 
      ObjectSet( box, OBJPROP_TIME1,t);
      ObjectSet( box, OBJPROP_PRICE1, ma1 );
      t = iTime( NULL, 0, MathCeil(0.8*WindowFirstVisibleBar())); 
      ObjectSet( box, OBJPROP_TIME2, t);
      ObjectSet( box, OBJPROP_PRICE2, ma1 + (40 * onepip)) ;
    }
    if ((p>= -40)&&(p<=0)) // draw red box
     { ObjectSet( box, OBJPROP_COLOR, Red);
      t = iTime( NULL, 0, WindowFirstVisibleBar()); // lhs 
      ObjectSet( box, OBJPROP_TIME1,t);
      ObjectSet( box, OBJPROP_PRICE1, ma1);
      t = iTime( NULL, 0, MathCeil(0.8*WindowFirstVisibleBar())); 
      ObjectSet( box, OBJPROP_TIME2, t);
      ObjectSet( box, OBJPROP_PRICE2, ma1 - (40 * onepip)) ;
    }
  }
       


//                                        - SnowMan's Alerts -
  /*  
  string sAlert, sMail, sCandleTime;
  string subject="Flying Buddha signal";
  if (newbar)
  {   sCandleTime=" Candle="+TimeToStr(Time[1]);
      //-- short alert
      if (ma200[1]==0)
      {  sAlert=Symbol()+" ("+Get_sPeriod(Period())+") SELL signal  [Flying Buddha]"+sCandleTime;
         sMail =sAlert + "  Time: " + TimeToStr(TimeCurrent());
         if (Enable_Alerts) Alert(sAlert);
         if (Enable_EMails) SendMail(subject, sMail);
      }
      
      //-- long alert
      if (ma200[1]==0)
      {
         sAlert=Symbol()+" ("+Get_sPeriod(Period())+") BUY signal  [Flying Buddha]"+sCandleTime;
         sMail =sAlert + "  Time: " + TimeToStr(TimeCurrent());
         if (Enable_Alerts) Alert(sAlert);
         if (Enable_EMails) SendMail(subject, sMail);
      }
  }
  */
   
  return(0);
  } //                  - end start -
  

int DPips(int i) // this returns how far price is from MA200 in pips.
{
 // Print("i = "+i);
  ma200[i] = iMA(NULL,0,MA_Period,0,MAMode,MAappliedprice,i); // store
  double 
    r = (MathRound((Close[i] - ma200[i])*topips)); 
  temp[i] = r; // store for debug only
  return(r);
}   

string Get_sPeriod(int timeframe)
{
   if (timeframe == PERIOD_M1) return("M1");
   if (timeframe == PERIOD_M5) return("M5");
   if (timeframe == PERIOD_M15) return("M15");
   if (timeframe == PERIOD_M30) return("M30");
   if (timeframe == PERIOD_H1) return("H1");
   if (timeframe == PERIOD_H4) return("H4");
   if (timeframe == PERIOD_D1) return("D1");
   if (timeframe == PERIOD_W1) return("W1");
   if (timeframe == PERIOD_MN1) return("MN1");
}

bool fNewBar()
{
  static datetime 
    Last_Time = 0; 
  
  if (Last_Time != Time[0]) // then a new bar
  {
    Last_Time = Time[0]; // for next call here
    return (True);
  }
  else return(False);
}
 
 //                                        - deinit() -
int deinit()
{
  ObjectDelete( box);
 
  return(0);
}

